CREATE OR REPLACE VIEW cs.command_store_v
  AS
    SELECT
      command_store_id,
      model_name,
      model_version_num,
      domain_root_aggregate_id,
      integrity_fingerprint,
      payload_data,
      requestor_data,
      audit_insert_date
    FROM cs.command_store;

COMMENT ON VIEW cs.command_store_v IS 'The command store objects purpose is to support the processing of the commands that conforms to CQRS or CQS design principles';

COMMENT ON COLUMN cs.command_store_v.command_store_id IS 
'This is a UUID for the command being recorded in the database.
This id will be generated by the miroservice''s application layer, and ensures uniqueness of the command within the domain.' ;

COMMENT ON COLUMN cs.command_store_v.model_name IS 
'This is the name of the command that is stored. It will be simple string.
If we refer to the example, then it will store name as RegisterCustomerCommand.' ;

COMMENT ON COLUMN cs.command_store_v.model_version_num IS 
'This stores the version of the schema used. It will be simple string.
As the business evolves the business functions and processes will also evolve, and thus resulting in new version of the commands. Examples of version could be 1, 1.1, 2, etc.' ;

COMMENT ON COLUMN cs.command_store_v.domain_root_aggregate_id  IS 
'The Domain Root Aggregate Identifier ' ;

COMMENT ON COLUMN cs.command_store_v.integrity_fingerprint IS 
'This will be a SHA-256 hash of the command data being stored in the database. 
UUID need not be part of the hash, as the UUID itself does not add to business functionality. 
The command model name, command version, command requestor data and command payload data need to be member of the HASH.
This is to ensure protection of commands from tampering, and also validated integrity of the commands if replay is required.' ;

COMMENT ON COLUMN cs.command_store_v.payload_data IS 
'This is unstructured data, e.g. a JSON data, holding the domain data for the command.
This is a mandatory field. The domain processing will use this data to process the commands, and make changes to the domain aggregates.' ;

COMMENT ON COLUMN cs.command_store_v.requestor_data IS 
'This is unstructured data, e.g. a JSON data, holding the information about the requester.
This is a mandatory field where the domain requires awareness of the requester. 
Under a trusted model, where microservice only accepts communication from trusted channel, who are taking care of the origination security, this may not be neccessary.' ;

COMMENT ON COLUMN cs.command_store_v.audit_insert_date  IS 
'The Date and Time the row was inserted into the table. ' ;


